Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1019437 (eyesight) - Review Request: eyesight - Hawaii desktop image viewer
Summary: Review Request: eyesight - Hawaii desktop image viewer
Keywords:
Status: CLOSED NEXTRELEASE
Alias: eyesight
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Antonio Trande
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: qt-reviews
TreeView+ depends on / blocked
 
Reported: 2013-10-15 17:15 UTC by Lubomir Rintel
Modified: 2013-10-16 20:29 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-10-16 16:24:47 UTC
anto.trande: fedora-review+


Attachments (Terms of Use)

Description Lubomir Rintel 2013-10-15 17:15:40 UTC
SPEC: http://v3.sk/~lkundrak/SPECS/eyesight.spec
SRPM: http://v3.sk/~lkundrak/SRPMS/eyesight-0.1.1-1.fc20.src.rpm

Description:

Image viewer for the Hawaii desktop.

Comment 1 Mario Blättermann 2013-10-15 18:16:47 UTC
# Bundles webp, which is BSD
License:        GPLv2+ and BSD

Libwebp is available separately for Fedora. As a consequence, you remove the bundled stuff:

# Make sure we don't build bundled stuff
rm -rf src/3rdparty/*

In this case you don't need to recognize the license of libwebp. But wouldn't it need libwebp-devel as a build requirement?


rm -rf $RPM_BUILD_ROOT
%defattr(-,root,root,-)
This is default for ages and could be safely dropped.


Your package contains translation files. That's why you need to use %find_lang:
http://fedoraproject.org/wiki/Packaging:Guidelines#Handling_Locale_Files

Comment 2 Antonio Trande 2013-10-15 19:16:56 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- update-desktop-database is invoked in %post and %postun if package contains
  desktop file(s) with a MimeType: entry.
  Note: desktop file(s) with MimeType entry in eyesight
  See: http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#desktop-
  database

- Documentations can be listed in a single %doc line

- Your package contains translation files.
  See http://fedoraproject.org/wiki/Packaging:Guidelines#Handling_Locale_Files

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)". Detailed output of licensecheck in
     /home/sagitter/1019437-eyesight/licensecheck.txt

> # Bundles webp, which is BSD
> License:        GPLv2+ and BSD

but you removed the Webp by

> # Make sure we don't build bundled stuff
> rm -rf src/3rdparty/*

Webp is installed as dependence.  

[!]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.

Update the  Changelog, please.

[x]: Sources contain only permissible code or content.
[!]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed

Please, remove %defattr(-,root,root,-)

[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory names).

Please, use %{name} macro instead of 'eyesight'

[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 2 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.

Please, remove rm -rf $RPM_BUILD_ROOT

[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or desktop-
     file-validate if there is such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: eyesight-0.1.1-1.fc21.i686.rpm
          eyesight-0.1.1-1.fc21.src.rpm
eyesight.i686: W: no-manual-page-for-binary eyesight
eyesight.src: W: invalid-url Source0: eyesight-0.1.1.tar.gz
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint eyesight
eyesight.i686: W: no-manual-page-for-binary eyesight
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'



Requires
--------
eyesight (rpmlib, GLIBC filtered):
    libQt5Core.so.5
    libQt5Gui.so.5
    libQt5PrintSupport.so.5
    libQt5Widgets.so.5
    libc.so.6
    libgcc_s.so.1
    libgcc_s.so.1(GCC_3.0)
    libm.so.6
    libpthread.so.0
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3)
    rtld(GNU_HASH)



Provides
--------
eyesight:
    eyesight
    eyesight(x86-32)
    mimehandler(image/bmp)
    mimehandler(image/gif)
    mimehandler(image/jpeg)
    mimehandler(image/png)
    mimehandler(image/tiff)
    mimehandler(image/webp)
    mimehandler(image/x-portable-anybitmap)
    mimehandler(image/x-portable-bitmap)
    mimehandler(image/x-portable-graymap)
    mimehandler(image/x-portable-pixmap)
    mimehandler(image/x-xbitmap)
    mimehandler(image/x-xpixmap)



Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -m fedora-rawhide-i386 -b 1019437
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG

Comment 3 Mario Blättermann 2013-10-15 19:23:19 UTC
(In reply to Antonio Trande from comment #2)
> Webp is installed as dependence.  
I assume you mean it is still missing from BuildRequires...?

Comment 4 Antonio Trande 2013-10-15 19:34:32 UTC
(In reply to Mario Blättermann from comment #3)
> (In reply to Antonio Trande from comment #2)
> > Webp is installed as dependence.  
> I assume you mean it is still missing from BuildRequires...?

By fedora-review, it has been installed automatically without an explicit BuildRequires.

Comment 5 Mario Blättermann 2013-10-15 19:44:10 UTC
(In reply to Antonio Trande from comment #4)
> By fedora-review, it has been installed automatically without an explicit
> BuildRequires.

Do you mean libwebp as a runtime requirement or libwebp-devel in BuildRequires? As far as I can see, libwebp-devel is only pulled in by ImageMagick-devel and vips-devel. I had actually expected it is needed at build time.

Comment 6 Antonio Trande 2013-10-15 19:48:32 UTC
(In reply to Mario Blättermann from comment #5)
> (In reply to Antonio Trande from comment #4)
> > By fedora-review, it has been installed automatically without an explicit
> > BuildRequires.
> 
> Do you mean libwebp as a runtime requirement or libwebp-devel in
> BuildRequires? 

Only libwebp.

Comment 7 Lubomir Rintel 2013-10-15 19:58:22 UTC
(In reply to Mario Blättermann from comment #1)
> # Bundles webp, which is BSD
> License:        GPLv2+ and BSD
> 
> Libwebp is available separately for Fedora. As a consequence, you remove the
> bundled stuff:
> 
> # Make sure we don't build bundled stuff
> rm -rf src/3rdparty/*
> 
> In this case you don't need to recognize the license of libwebp. But
> wouldn't it need libwebp-devel as a build requirement?

It does not get built. I have clarified the comment.

> rm -rf $RPM_BUILD_ROOT
> %defattr(-,root,root,-)
> This is default for ages and could be safely dropped.

Done.


> Your package contains translation files. That's why you need to use
> %find_lang:
> http://fedoraproject.org/wiki/Packaging:Guidelines#Handling_Locale_Files

Done, thought it does not play well with some translations.
Will report upstream.

(In reply to Antonio Trande from comment #2)
> > # Bundles webp, which is BSD
> > License:        GPLv2+ and BSD
> 
> but you removed the Webp by
> 
> > # Make sure we don't build bundled stuff
> > rm -rf src/3rdparty/*
> 
> Webp is installed as dependence.  

See above.

> Please, remove %defattr(-,root,root,-)

Done, see above.

> [!]: Package consistently uses macros (instead of hard-coded directory
> names).
> 
> Please, use %{name} macro instead of 'eyesight'

No. That serves no purpose, harms readability and is not required by the guidelines.

> Please, remove rm -rf $RPM_BUILD_ROOT

Done.

Thank you for the review. Here's the updated package:

SPEC: http://v3.sk/~lkundrak/SPECS/eyesight.spec
SRPM: http://v3.sk/~lkundrak/SRPMS/eyesight-0.1.1-2.fc20.src.rpm

Comment 8 Mario Blättermann 2013-10-15 20:10:35 UTC
(In reply to Lubomir Rintel from comment #7)
> (In reply to Antonio Trande from comment #2)
> > Please, use %{name} macro instead of 'eyesight'
> 
> No. That serves no purpose, harms readability and is not required by the
> guidelines.

Indeed, we are not forced to use macros in this case. The main meaning of consistency is to don't mix shell variables and macros with the same value, for example $RPM_BUILD_ROOT and %{buildroot}.
In some cases reviewers even are a bit piqued if they read URLs containing macros, so that they cannot copy and paste them. No problem for me, I run rpmlint, and I get proper and macro-free links.

Comment 9 Antonio Trande 2013-10-15 20:15:45 UTC
> >(In reply to Lubomir Rintel from comment #7)
> > No. That serves no purpose, harms readability and is not required by the
> > guidelines.

> (In reply to Mario Blättermann from comment #8)
> Indeed, we are not forced to use macros in this case. The main meaning of
> consistency is to don't mix shell variables and macros with the same value,
> for example $RPM_BUILD_ROOT and %{buildroot}.
> In some cases reviewers even are a bit piqued if they read URLs containing
> macros, so that they cannot copy and paste them. No problem for me, I run
> rpmlint, and I get proper and macro-free links.


Okay.
Package approved.

Comment 10 Lubomir Rintel 2013-10-16 06:54:35 UTC
Thank you, Antonio!

New Package SCM Request
=======================
Package Name: eyesight
Short Description: Hawaii desktop image viewer
Owners: lkundrak cicku
Branches: f18 f19 f20 el6

Comment 11 Gwyn Ciesla 2013-10-16 12:33:54 UTC
Complete.

Comment 12 Lubomir Rintel 2013-10-16 16:24:47 UTC
Thank you!

Imported and built.

Comment 13 Kevin Kofler 2013-10-16 20:29:47 UTC
> # These short-named translations probably need renaming upstream, since they 
> # are not picked up by find_lang
> %{_datadir}/eyesight/translations/??.qm

IMHO, this should have been a review blocker. The only valid way to handle translations not found by %find_lang is to list them all explicitly one by one with the corresponding %lang(??) tag for each.


Note You need to log in before you can comment on or make changes to this bug.